!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2006. All rights reserved.
!---------------------------------------------------------------------
!= Module Radiation
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: radiation.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview
!
!ǥͲ׻뤿Υѥå⥸塼
!Ūˤϰʲι׻뤿δؿǼ.  
!  * 
!
!== Error Handling
!
!== Bugs
!
!== Note
!
!
!== Future Plans
!
!

module Radiation
  !
  !ǥͲ׻뤿Υѥå⥸塼
  !Ūˤϰʲι׻뤿δؿǼ.  
  !  * 
  !

  !⥸塼ɤ߹
  use GridSet,  only: DimXMin,     & !x β
    &                 DimXMax,     & !x ξ
    &                 DimZMin,     & !z β
    &                 DimZMax,     & !z ξ
    &                 s_Z            !Z ɸ(顼ʻ)
  use TimeSet,  only: DayTime        ! 1 Ĺ [s]
  use basicset, only: xz_ExnerBasicZ !ʡؿδܾ
  
  !ۤηػ
  implicit none

  !private °
  private

  !ؿ public ˤ. 
  public xz_RadCoolConst, Radiation_init

  !ѿ
  real(8) :: RadHeatRate = 0.0d0   !ͲǮΨ [K/day]
  real(8) :: RadHeight   = 0.0d0   !ͲǮ¸ߤΰκ [m]

  !save °
  save RadHeatRate, RadHeight

contains

!!!------------------------------------------------------------------------!!!
  subroutine Radiation_init(cfgfile)
    !
    !NAMELIST Ͷ
    !

    !ۤηػ
    implicit none

    !ѿ
    character(*), intent(in) :: cfgfile

    ! NAMELIST 
    NAMELIST /radiation/ RadHeatRate, RadHeight

    open (10, FILE=cfgfile)
    read(10, NML=radiation)
    close(10)

    write(*,*) "Radiation, RadHeatRate: ", RadHeatRate
    write(*,*) "Radiation, RadHeight:   ", RadHeight
    
  end subroutine Radiation_init


!!!------------------------------------------------------------------------!!!
  function xz_RadCoolConst(xz_Exner)
    !
    ! ̤Ͷ. 
    ! ɽ̤ RadHeight ǻꤵ줿٤ޤǤδ֤ǰѤͿ. 
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
                                       !ʡؿξ
    real(8)               :: xz_RadCoolConst(DimXMin:DimXMax, DimZMin:DimZMax)
                                       !Ͷ
    integer               :: k         !롼ѿ

    xz_RadCoolConst = 0.0d0
    do k = DimZMin, DimZMax
      if ( s_Z(k) <= RadHeight ) then
        xz_RadCoolConst(DimXMin:DimXMax, k) = RadHeatRate   &
          & / (     &
          &     (     &
          &         xz_ExnerBasicZ(DimXMin:DimXMax, k)   &
          &       + xz_Exner(DimXMin:DimXMax, k)      &
          &     ) * DayTime    &
          &   )
      else
        xz_RadCoolConst(DimXMin:DimXMax, k) = - 0.0d0
      end if
    end do
    
  end function xz_RadCoolConst
  
end module Radiation
